/* Audio Interchange File Format routines */
#include	<math.h>
#include	<SANE.h>
#define	pstring	Str255
#define	ID						long		/* ID for AIFF chunk ckID's */

#define	CommonID				'COMM'	/* ckID for Common Chunk */
#define	SoundDataID				'SSND'	/* ckID for Sound Data Chunk */
#define	MarkerID				'MARK'	/* ckID for Marker Chunk */
#define	InstrumentID			'INST'	/* ckID for Instrument Chunk */
#define	MIDIDataID 				'MIDI'	/* ckID for MIDI Data Chunk */
#define	AudioRecordingID		'AESD'		/* ckID for Audio Recording */
#define	ApplicationSpecificID	'APPL'  /* ckID for Application Specific Chunk.     */
#define	CommentID				'COMT'	/* ckID for Comments Chunk.  */
#define	NameID					'NAME'	/* ckID for Name Chunk.  */
#define	AuthorID				'AUTH'	/* ckID for Author Chunk.  */
#define	CopyrightID				'(c) '	/* ckID for Copyright Chunk.  */
#define	AnnotationID			'ANNO'	/* ckID for Annotation Chunk.  */

#define	SixteenBits				16

#define	NoLooping				0
#define	ForwardLooping			1
#define	ForwardBackwardLooping	2




/* FORM */
typedef struct {

	ID			ckID;	/* = 'FORM' */
	long			ckSize;

	ID			formType;	/* = 'AIFF' */
	char			chunks [];

} Chunk;

typedef struct {

	ID			ckID;
	long		ckSize;

	char		ckData [];

} BasicChunk;

typedef struct {

	ID			ckID;	
	long			ckSize;

	short			numChannels;
	unsigned long	numSampleFrames;	/* nsamples/ nchans */
	short			sampleSize;			/* no of bits (1-32) */
	extended80		sampleRate;		/* sample FRAMES / sec */

} CommonChunk;	


typedef struct {

	ID				ckID;
	long				ckSize;

	unsigned long		offset;		/* usually 0 */
	unsigned long		blockSize;	/*   ditto */
	unsigned char		soundData[];	/* sample frames */

} SoundDataChunk;



typedef	short	MarkerId;

typedef struct {

	MarkerId			id;
	unsigned long		position;
	pstring			markerName;

} Marker;


typedef struct {

	ID				ckID;	
	long				ckSize;

	unsigned short		numMarkers;
	Marker			Markers[];

} MarkerChunk;


typedef struct {

	short			playMode;
	MarkerId		beginLoop;
	MarkerId		endLoop;

} Loop;

typedef struct {

	ID			ckID;	
	long			ckSize;

	char			baseNote;
	char			detune;
	char			lowNote;
	char			highNote;
	char			lowVelocity;
	char			highVelocity;
	short			gain;
	Loop			sustainLoop;
	Loop			releaseLoop;

} InstrumentChunk;


typedef struct {

	ID				ckID;
	long				ckSize;

	unsigned char		MIDIdata[];

} MIDIDataChunk;



typedef struct {
	
	ID				ckID;
	long				ckSize;

	unsigned char		AESChannelStatusData[24];

} AudioRecordingChunk;
	
typedef struct {

	ID			ckID;	
	long			ckSize;

	OSType		applicationSignature;
	char			data[];

} ApplicationSpecificChunk;

typedef struct {

	unsigned long		timeStamp;
	MarkerId			marker;
	unsigned short		count;
	char				text;

} Comment;

typedef struct {

	ID				ckID;
	long				ckSize;

	unsigned short		numComments;
	Comment			comments[];

} CommentsChunk;



typedef struct {

	ID				ckID;
	long				ckSize;

	char				text[];

} TextChunk;





