/*
*  Graeme Gerrard 1990
* Faculty of Music, University of Melbourne
* Parkville Victoria 3052 Australia.
*
* ARPANET: grae@murdu.ucs.unimelb.edu.au
* telephone: (613) 344 4127, Fax: (613) 344 5346
*/

#define	leftChan	1.0
#define	rightChan	0.0


/* common variables required by all "orch" routines */

extern	double	tt;				/* time from start of run */
extern	double	t;				/* time from start of section */
extern	double	*p;		/* parameter array */
extern	int		npargs;			/* number of parameter arguments */
extern	int		instype;			/* current instrument type */
extern	int		insno;			/* instrument index number for this type */
extern	int		nchnls;			/* max number of output channels */
extern	int		on[MAXINSTRS+1];	/* indicates if instrument is to play */
extern	double	*out;	/* storage for samples */
extern	int		loc;				/* pointer to out array for basic channel */
extern	double	srate;			/* sample rate */
extern	double	*F[MAXFUNCS];		/* function storage */


double add8vepc(double, double);
void en3set( double, double, double, double * );
double envel3(double, int, double *);
double envel3I(double, int, double *);
void adsrset( double, double, double, double, double * );
double adsr(double, int, double *);
void blnset( double, double, double * );
void cmbset( double, double, double * );
void slpset(double *, double *, double);
double slope(double *, double *);
void toneset( double, double, double * );
double tone(double, double *);
void evpset(double, double, double, double, int, int, double *);
double envlp(double, int, int, double *);
void expset(double *, double *, double);
double expon(double *, double *);
double formnt(double, double, int, int, int, int, double *);
void hf2set(double, double, double *);
double hpf2(double, double *);
void linset(double, double, double, double *);
double linens(double, double *);
double nonlin(double, double, int);
double oscil(double, double, int, double *);
double oscil1(double, double, int, double *);
double osci1(double, double, int, double *);
double oscili(double, double, int, double *);
void rsnset(double, double, double, double, double *);
double reson(double, double *);
void vrsset( double, double, double * );
double vreson(double, double, double, double, int, double *);
void mono(double);
void output(double, double, double, double);
void stereo(double, double);
double ilookup(double, int);
double vfmult(double, double, int);
double cpsoct(double);
double cpspch(double);
double cycle(double);
double octave(double);
double octcps(double);
double octpch(double);
double pchcps(double);
double pchoct(double);
double period(double);
double pitch(double);
double sicps(double);
double random(double *);
double drand(double, double *);
double randh(double, double, double *);
double	randf(double, double, double *);
double randfi(double, double, double *);
double randfc(double, double, double *, double *, double *);
double randfh(double, double, double *);
double randi(double, double, double *);
double alpass(double, double, double *);
double balnce(double, double, double *);
void coscurv(double *, double *);
double comb(double, double, double *);
double buzz(double, double, double, int, double *);
void rvbset(double, double *);
double reverb(double, double, double * );
void rvb2set(double, double, double *, double * );
double reverb2(double, double *);
double alpass2(double, double *);
double comb2(double, double *);
double zdelay(double, double, int, double *, double *);
double sdelay(double, int, double *, double *);


read_set(char *, float *, int, double *, int *);
double	readsfi(int, double, float *, int, double *);
Boolean SF_FLOAT_ReadSet(double *, int, double *, ParmBlkPtr, double *, long *, long *);
double	SF_FLOAT_Read(ParmBlkPtr, double, double *, int, double *, double *, long *, long *);
Boolean SF_SD_1_ReadSet(double *, int, double *, ParmBlkPtr, double *, long *, long *);
double	SF_SD_1_Read(ParmBlkPtr, double, double *, int, double *, double *, long *, long *);
Boolean SF_SD_2_ReadSet(double *, int, double *, ParmBlkPtr, double *, long *, long *);
double	SF_SD_2_Read(ParmBlkPtr, double, double *, int, double *, double *, long *, long *);

/*-------------------------------------------------------------------------------*/
void initl(void);
void setup(void);
void orch(void);
void ter(void);
void final(void);
